#!/bin/bash
#
# lancio dello script:
# ./stats -a -h	: stampa header, una misura ogni 5 sec, interruzione via ^c
# ./stats -a	: una misura ogni 5 sec, interruzione via ^c
# ./stats -h	: stampa header, una sola misura
# ./stats 	: una sola misura 
#
if [ "$1" == "-a" ] || [ "$2" == "-a" ]
	then auto="yes"
	else auto="no"
	fi
if [ "$1" == "-h" ] || [ "$2" == "-h" ]
	then hdr="yes"
	else hdr="no"
	fi
if [ "$auto" == "yes" ]
	then
		commento="auto"
		echo interrompi l\'esecuzione con ^C
	else read -p "inserisci il commento: " commento
	fi
if [ "$hdr" == "yes" ]
	then printf "Time\tMem used\tSwap used\tpswpin\tpswpout\tcomment\tevent\n" |
        	tee -a log_swap.csv
	fi
#
while :
do
	used=$(free | awk 'BEGIN {FS=" "; OFS="\t"}
		{if ($1 == "Mem:") print $3}
		{if ($1 == "Swap:") print "-" $3}
		')
	MemUsed=$(echo $used | cut -f1 -d-)
	SwapUsed=$(echo $used | cut -f2 -d-)
	if [ "$auto" == "yes" ]
		then
			event=""
		else
			event=$MemUsed
		fi
#
	swap=$(cat /proc/vmstat |grep pswp)
	pswapin=$(echo $swap | cut -f2 -d ' ')
	pswapout=$(echo $swap | cut -f4 -d ' ')
#
	printf "%s\t%s\t%s\t%s\t%s\t%s\t%s\n" "$(date +"%T")" "$MemUsed" "$SwapUsed" "$pswapin" "$pswapout" "$commento" "$event" |
        	tee -a log_swap.csv
	if [ "$auto" != "yes" ]
	then
		break
	else
		sleep 5
	fi
done
